Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/syssvc/tlsf/tlsf.h
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/syssvc/tlsf/tlsf.h	(revision 387)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/syssvc/tlsf/tlsf.h	(revision 387)
@@ -0,0 +1,90 @@
+#ifndef INCLUDED_tlsf
+#define INCLUDED_tlsf
+
+/*
+** Two Level Segregated Fit memory allocator, version 3.1.
+** Written by Matthew Conte
+**	http://tlsf.baisoku.org
+**
+** Based on the original documentation by Miguel Masmano:
+**	http://www.gii.upv.es/tlsf/main/docs
+**
+** This implementation was written to the specification
+** of the document, therefore no GPL restrictions apply.
+** 
+** Copyright (c) 2006-2016, Matthew Conte
+** All rights reserved.
+** 
+** Redistribution and use in source and binary forms, with or without
+** modification, are permitted provided that the following conditions are met:
+**     * Redistributions of source code must retain the above copyright
+**       notice, this list of conditions and the following disclaimer.
+**     * Redistributions in binary form must reproduce the above copyright
+**       notice, this list of conditions and the following disclaimer in the
+**       documentation and/or other materials provided with the distribution.
+**     * Neither the name of the copyright holder nor the
+**       names of its contributors may be used to endorse or promote products
+**       derived from this software without specific prior written permission.
+** 
+** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+** ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+** WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+** DISCLAIMED. IN NO EVENT SHALL MATTHEW CONTE BE LIABLE FOR ANY
+** DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+** (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+** LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+** ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+*/
+
+#include <stddef.h>
+
+#if defined(__cplusplus)
+extern "C" {
+#endif
+
+/* tlsf_t: a TLSF structure. Can contain 1 to N pools. */
+/* pool_t: a block of memory that TLSF can manage. */
+typedef void* tlsf_t;
+typedef void* pool_t;
+
+/* Create/destroy a memory pool. */
+tlsf_t tlsf_create(void* mem);
+tlsf_t tlsf_create_with_pool(void* mem, size_t bytes);
+void tlsf_destroy(tlsf_t tlsf);
+pool_t tlsf_get_pool(tlsf_t tlsf);
+
+/* Add/remove memory pools. */
+pool_t tlsf_add_pool(tlsf_t tlsf, void* mem, size_t bytes);
+void tlsf_remove_pool(tlsf_t tlsf, pool_t pool);
+
+/* malloc/memalign/realloc/free replacements. */
+void* tlsf_malloc(tlsf_t tlsf, size_t bytes);
+void* tlsf_memalign(tlsf_t tlsf, size_t align, size_t bytes);
+void* tlsf_realloc(tlsf_t tlsf, void* ptr, size_t size);
+void tlsf_free(tlsf_t tlsf, void* ptr);
+
+/* Returns internal block size, not original request size */
+size_t tlsf_block_size(void* ptr);
+
+/* Overheads/limits of internal structures. */
+size_t tlsf_size(void);
+size_t tlsf_align_size(void);
+size_t tlsf_block_size_min(void);
+size_t tlsf_block_size_max(void);
+size_t tlsf_pool_overhead(void);
+size_t tlsf_alloc_overhead(void);
+
+/* Debugging. */
+typedef void (*tlsf_walker)(void* ptr, size_t size, int used, void* user);
+void tlsf_walk_pool(pool_t pool, tlsf_walker walker, void* user);
+/* Returns nonzero if any internal consistency check fails. */
+int tlsf_check(tlsf_t tlsf);
+int tlsf_check_pool(pool_t pool);
+
+#if defined(__cplusplus)
+};
+#endif
+
+#endif
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/target/gr_peach_gcc/gr_peach.h
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/target/gr_peach_gcc/gr_peach.h	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/target/gr_peach_gcc/gr_peach.h	(revision 387)
@@ -58,4 +58,9 @@
 
 /*
+ *  ボーレート設定
+ */
+#define UART_BAUDRATE		115200
+
+/*
  *  LEDの点灯／消灯
  */
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/target/gr_peach_gcc/target.cdl
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/target/gr_peach_gcc/target.cdl	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/target/gr_peach_gcc/target.cdl	(revision 387)
@@ -60,5 +60,5 @@
  *  ターゲット依存のセルタイプの定義
  */
-import("tPutLogGRPeach.cdl");
+import("syssvc/tPutLogSIOPort.cdl");
 import("tSIOPortGRPeach.cdl");
 
@@ -72,5 +72,5 @@
  *  低レベル出力の組み上げ記述
  */
-cell tPutLogGRPeach PutLogTarget {
+cell tPutLogSIOPort PutLogTarget {
 	/* SIOドライバとの結合 */
 	cSIOPort = SIOPortTarget1.eSIOPort;
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/target/gr_peach_gcc/target_kernel_impl.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/target/gr_peach_gcc/target_kernel_impl.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/target/gr_peach_gcc/target_kernel_impl.c	(revision 387)
@@ -264,5 +264,5 @@
 	 */
 #ifndef TOPPERS_OMIT_TECS
-	tPutLogGRPeach_initialize();
+	tPutLogSIOPort_initialize();
 #endif /* TOPPERS_OMIT_TECS */
 }
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/in_itron.h
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/in_itron.h	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/in_itron.h	(revision 387)
@@ -131,4 +131,5 @@
 extern ER_UINT	udp6_snd_dat (ID cepid, T_IPV6EP *p_dstaddr, void *data, int_t len, TMO tmout);
 extern ER_UINT	udp6_rcv_dat (ID cepid, T_IPV6EP *p_dstaddr, void *data, int_t len, TMO tmout);
+extern ER	udp6_can_cep(ID cepid, FN fncd);
 
 /* 【拡張機能】 */
@@ -139,4 +140,7 @@
 extern ER	udp_cre_cep (ID cepid, T_UDP_CCEP *pk_ccep);
 
+extern ER	udp6_del_cep(ID cepid);
+extern ER	udp6_set_opt(ID cepid, int_t optname, void *optval, int_t optlen);
+extern ER	udp6_get_opt(ID cepid, int_t optname, void *optval, int_t optlen);
 extern ER	udp6_cre_cep (ID cepid, T_UDP6_CCEP *pk_ccep);
 
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/tcp_input.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/tcp_input.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/tcp_input.c	(revision 387)
@@ -521,5 +521,19 @@
 
 				/* 相手のアドレスをコピーする。*/
+
+#if defined(_IP6_CFG) && defined(_IP4_CFG)
+
+				if (cep->flags & TCP_CEP_FLG_IPV4) {
+					(*cep->p_dstaddr4).ipaddr = ntohl(cep->dstaddr.ipaddr.s6_addr32[3]);
+					(*cep->p_dstaddr4).portno = cep->dstaddr.portno;
+					}
+				else
+					*cep->p_dstaddr = cep->dstaddr;
+
+#else	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) */
+
 				*cep->p_dstaddr = cep->dstaddr;
+
+#endif	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) */
 
 				if (IS_PTR_DEFINED(cep->callback)) {
@@ -847,5 +861,19 @@
 
 				/* 相手のアドレスをコピーする。*/
+
+#if defined(_IP6_CFG) && defined(_IP4_CFG)
+
+				if (cep->flags & TCP_CEP_FLG_IPV4) {
+					(*cep->p_dstaddr4).ipaddr = ntohl(cep->dstaddr.ipaddr.s6_addr32[3]);
+					(*cep->p_dstaddr4).portno = cep->dstaddr.portno;
+					}
+				else
+					*cep->p_dstaddr = cep->dstaddr;
+
+#else	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) */
+
 				*cep->p_dstaddr = cep->dstaddr;
+
+#endif	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) */
 
 				if (IS_PTR_DEFINED(cep->callback)) {
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/tcpn_usrreq.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/tcpn_usrreq.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/tcpn_usrreq.c	(revision 387)
@@ -671,10 +671,10 @@
 		cep->p_myaddr4    = p_myaddr;
 		cep->p_dstaddr    = NULL;
-		cep->p_myaddr     = NULL;
+		cep->p_myaddr     = NADR;
 
 #else	/* of #if API_PROTO == API_PROTO_IPV4 */
 
 		cep->p_dstaddr4   = NULL;
-		cep->p_myaddr4    = NULL;
+		cep->p_myaddr4    = NADR;
 		cep->p_dstaddr    = p_dstaddr;
 		cep->p_myaddr     = p_myaddr;
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udp_output.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udp_output.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udp_output.c	(revision 387)
@@ -182,5 +182,5 @@
 #if defined(_IP6_CFG) && TNUM_UDP6_CEPID > 0
 
-		for (ix = tmax_udp6_cepid; ix -- > 0; ) {
+		for (ix = TNUM_UDP6_CEPID - 1; ix -- > 0; ) {
 
 			if (udp6_cep[ix].flags & UDP_CEP_FLG_POST_OUTPUT) {
@@ -194,5 +194,5 @@
 #if defined(_IP4_CFG) && TNUM_UDP4_CEPID > 0
 
-		for (ix = tmax_udp4_cepid; ix -- > 0; ) {
+		for (ix = TNUM_UDP4_CEPID - 1; ix -- > 0; ) {
 
 			if (udp4_cep[ix].flags & UDP_CEP_FLG_POST_OUTPUT) {
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udp_subr.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udp_subr.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udp_subr.c	(revision 387)
@@ -146,5 +146,5 @@
 #define UDP_FIND_CEP		udp6_find_cep
 #define UDP_NOTIFY		udp6_notify
-#define TMAX_UDP_CEPID		tmax_udp6_cepid
+#define TMAX_UDP_CEPID		(TNUM_UDP6_CEPID - 1)
 #define UDP_CEP			udp6_cep
 #define T_UDP_CEP		T_UDP6_CEP
@@ -183,5 +183,5 @@
 #define UDP_FIND_CEP		udp4_find_cep
 #define UDP_NOTIFY		udp4_notify
-#define TMAX_UDP_CEPID		tmax_udp4_cepid
+#define TMAX_UDP_CEPID		(TNUM_UDP4_CEPID - 1)
 #define T_UDP_CEP		T_UDP4_CEP
 #define UDP_CEP			udp4_cep
Index: asp3_tinet_ecnl_arm/trunk/bnep_bridge/Debug/Makefile
===================================================================
--- asp3_tinet_ecnl_arm/trunk/bnep_bridge/Debug/Makefile	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/bnep_bridge/Debug/Makefile	(revision 387)
@@ -58,5 +58,6 @@
 	LIBS = $(SRCDIR)/../musl-1.1.18/Debug/libmusl.a \
 		$(SRCDIR)/../btstack/Debug/libbtstack.a \
-		$(SRCDIR)/../usbhost/Debug/libusbhost.a
+		$(SRCDIR)/../usbhost/Debug/libusbhost.a \
+		$(SRCDIR)/../zlib-1.2.11/Debug/libzlib.a
 endif
 ifeq ($(SRCLANG),c++)
@@ -189,9 +190,9 @@
 #
 APPLNAME = bnep_bridge
-APPLDIRS = ../src ../../ntshell/tlsf ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
+APPLDIRS = ../src ../../ntshell/fatfs ../../ntshell/ntshell ../../ntshell/ntshell/core ../../ntshell/ntshell/util ../../ntshell/src $(SRCDIR)/$(TINETDIR)/netapp
 APPL_CFG = main.cfg
 APPL_CDL = main.cdl
 
-APPL_COBJS := $(APPL_COBJS) ntshell_main.o fdtable.o io_stub.o ffarch.o diskio.o ff.o sdfs.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o tlsf.o
+APPL_COBJS := $(APPL_COBJS) ntshell_main.o fdtable.o stdio_stub.o io_stub.o ffarch.o diskio.o ff.o sdfs.o ccsbcs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o
 
 APPL_DIRS := $(APPLDIRS) $(SRCDIR)/library
Index: asp3_tinet_ecnl_arm/trunk/bnep_bridge/src/main.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/bnep_bridge/src/main.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/bnep_bridge/src/main.c	(revision 387)
@@ -54,9 +54,6 @@
 #include "ffarch.h"
 #include "ff.h"
-#include "core/ntshell.h"
-#include "core/ntlibc.h"
 #include <stdio.h>
 #include "usrcmd.h"
-#include "util/ntopt.h"
 #include "gpio_api.h"
 #include "usb_hbth.h"
Index: asp3_tinet_ecnl_arm/trunk/bnep_bridge/src/main.cdl
===================================================================
--- asp3_tinet_ecnl_arm/trunk/bnep_bridge/src/main.cdl	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/bnep_bridge/src/main.cdl	(revision 387)
@@ -22,5 +22,5 @@
  *  ターゲット依存部の取り込み
  */
-import("target.cdl");
+import("ntshell.cdl");
 
 /*
Index: asp3_tinet_ecnl_arm/trunk/curl-7.57.0/lib/easy.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/curl-7.57.0/lib/easy.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/curl-7.57.0/lib/easy.c	(revision 387)
@@ -166,11 +166,4 @@
 #endif
 
-#ifdef __c2__
-#define malloc musl_malloc
-#define free musl_free
-#define realloc musl_realloc
-#define calloc musl_calloc
-#endif
-
 #ifndef __SYMBIAN32__
 /*
Index: asp3_tinet_ecnl_arm/trunk/curl-7.57.0/lib/security.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/curl-7.57.0/lib/security.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/curl-7.57.0/lib/security.c	(revision 387)
@@ -8,5 +8,5 @@
  * below.
  *
- * Copyright (c) 1998, 1999, 2017 Kungliga Tekniska H旦gskolan
+ * Copyright (c) 1998, 1999, 2017 Kungliga Tekniska Hogskolan
  * (Royal Institute of Technology, Stockholm, Sweden).
  *
Index: asp3_tinet_ecnl_arm/trunk/musl-1.1.18/include/bits/alltypes.h
===================================================================
--- asp3_tinet_ecnl_arm/trunk/musl-1.1.18/include/bits/alltypes.h	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/musl-1.1.18/include/bits/alltypes.h	(revision 387)
@@ -1,34 +1,2 @@
-#if defined(_MSC_VER) || defined(__c2__)
-#define close musl_close
-#define execvp musl_execvp
-#define fclose musl_fclose
-#define fdopen musl_fdopen
-#define fflush musl_fflush
-#define fopen musl_fopen
-#define free musl_free
-#define fwrite musl_fwrite
-#define getcwd musl_getcwd
-#define localtime musl_localtime
-#define lseek musl_lseek
-#define open musl_open
-#define read musl_read
-#define malloc musl_malloc
-#define calloc musl_calloc
-#define realloc musl_realloc
-#define time musl_time
-#define unlink musl_unlink
-#define perror musl_perror
-#define strnlen musl_strnlen
-#define strftime musl_strftime
-#define asctime musl_asctime
-#define tzset musl_tzset
-#define clock musl_clock
-#endif
-#ifdef _MSC_VER
-#define __builtin_va_list char *
-#define __NEED_va_list
-#define restrict __restrict
-#endif
-
 #define _Addr int
 #define _Int64 long long
Index: asp3_tinet_ecnl_arm/trunk/musl-1.1.18/include/stddef.h
===================================================================
--- asp3_tinet_ecnl_arm/trunk/musl-1.1.18/include/stddef.h	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/musl-1.1.18/include/stddef.h	(revision 387)
@@ -11,5 +11,5 @@
 #define __NEED_size_t
 #define __NEED_wchar_t
-#if __STDC_VERSION__ >= 201112L || __cplusplus >= 201103L
+#if __STDC_VERSION__ >= 201112L || (defined(__cplusplus) && __cplusplus >= 201103L)
 #define __NEED_max_align_t
 #endif
Index: asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/locale/__lctrans.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/locale/__lctrans.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/locale/__lctrans.c	(revision 387)
@@ -8,7 +8,5 @@
 }
 
-#ifndef __c2__
 weak_alias(dummy, __lctrans_impl);
-#endif
 
 const char *__lctrans(const char *msg, const struct __locale_map *lm)
Index: asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/locale/__mo_lookup.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/locale/__mo_lookup.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/locale/__mo_lookup.c	(revision 387)
@@ -4,5 +4,5 @@
 static inline uint32_t swapc(uint32_t x, int c)
 {
-	return c ? x>>24 | x>>8&0xff00 | x<<8&0xff0000 | x<<24 : x;
+	return c ? (x>>24) | (x>>8&0xff00) | (x<<8&0xff0000) | (x<<24) : x;
 }
 
Index: asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/locale/iconv.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/locale/iconv.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/locale/iconv.c	(revision 387)
@@ -136,5 +136,5 @@
 {
 	e &= 3;
-	return s[e]+0U<<24 | s[e^1]<<16 | s[e^2]<<8 | s[e^3];
+	return (s[e]+0U)<<24 | s[e^1]<<16 | s[e^2]<<8 | s[e^3];
 }
 
@@ -156,5 +156,5 @@
 	unsigned x = c - 128 - map[-1];
 	x = legacy_chars[ map[x*5/4]>>2*x%8 |
-		map[x*5/4+1]<<8-2*x%8 & 1023 ];
+		(map[x*5/4+1]<<(8-2*x%8) & 1023) ];
 	return x ? x : c;
 }
@@ -348,5 +348,5 @@
 				c += (0xa1-0x81);
 				d += 0xa1;
-				if (c >= 93 || c>=0xc6-0x81 && d>0x52)
+				if (c >= 93 || (c>=0xc6-0x81 && d>0x52))
 					goto ilseq;
 				if (d-'A'<26) d = d-'A';
Index: asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/locale/locale_map.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/locale/locale_map.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/locale/locale_map.c	(revision 387)
@@ -36,7 +36,7 @@
 
 	if (!*val) {
-		(val = getenv("LC_ALL")) && *val ||
-		(val = getenv(envvars[cat])) && *val ||
-		(val = getenv("LANG")) && *val ||
+		((val = getenv("LC_ALL")) && *val) ||
+		((val = getenv(envvars[cat])) && *val) ||
+		((val = getenv("LANG")) && *val) ||
 		(val = "C.UTF-8");
 	}
Index: asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/malloc/memalign.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/malloc/memalign.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/malloc/memalign.c	(revision 387)
@@ -46,8 +46,8 @@
 	footer = ((size_t *)end)[-2];
 
-	((size_t *)mem)[-1] = header&7 | new-mem;
-	((size_t *)new)[-2] = footer&7 | new-mem;
-	((size_t *)new)[-1] = header&7 | end-new;
-	((size_t *)end)[-2] = footer&7 | end-new;
+	((size_t *)mem)[-1] = (header&7) | new-mem;
+	((size_t *)new)[-2] = (footer&7) | new-mem;
+	((size_t *)new)[-1] = (header&7) | end-new;
+	((size_t *)end)[-2] = (footer&7) | end-new;
 
 	free(mem);
Index: asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/math/fma.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/math/fma.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/math/fma.c	(revision 387)
@@ -70,5 +70,5 @@
 		if (d < 64) {
 			zlo = nz.m<<d;
-			zhi = nz.m>>64-d;
+			zhi = nz.m>>(64-d);
 		} else {
 			zlo = 0;
@@ -78,5 +78,5 @@
 			if (d == 0) {
 			} else if (d < 64) {
-				rlo = rhi<<64-d | rlo>>d | !!(rlo<<64-d);
+				rlo = rhi<<(64-d) | rlo>>d | !!(rlo<<(64-d));
 				rhi = rhi>>d;
 			} else {
@@ -91,5 +91,5 @@
 			zlo = nz.m;
 		} else if (d < 64) {
-			zlo = nz.m>>d | !!(nz.m<<64-d);
+			zlo = nz.m>>d | !!(nz.m<<(64-d));
 		} else {
 			zlo = 1;
@@ -123,5 +123,5 @@
 		d = a_clz_64(rhi)-1;
 		/* note: d > 0 */
-		rhi = rhi<<d | rlo>>64-d | !!(rlo<<d);
+		rhi = rhi<<d | rlo>>(64-d) | !!(rlo<<d);
 	} else if (rlo) {
 		d = a_clz_64(rlo)-1;
@@ -174,5 +174,5 @@
 			/* only round once when scaled */
 			d = 10;
-			i = ( rhi>>d | !!(rhi<<64-d) ) << d;
+			i = ( rhi>>d | !!(rhi<<(64-d)) ) << d;
 			if (sign)
 				i = -i;
Index: asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/network/lookup_name.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/network/lookup_name.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/musl-1.1.18/src/network/lookup_name.c	(revision 387)
@@ -11,4 +11,5 @@
 #include <pthread.h>
 #include <errno.h>
+#include <resolv.h>
 #include "lookup.h"
 #include "stdio_impl.h"
@@ -185,4 +186,8 @@
 	if (dots >= conf.ndots || name[l-1]=='.') *search = 0;
 
+	/* Strip final dot for canon, fail if multiple trailing dots. */
+	if (name[l-1]=='.') l--;
+	if (!l || name[l-1]=='.') return EAI_NONAME;
+
 	/* This can never happen; the caller already checked length. */
 	if (l >= 256) return EAI_NONAME;
@@ -311,5 +316,5 @@
 	if (!cnt && !(flags & AI_NUMERICHOST)) {
 		cnt = name_from_hosts(buf, canon, name, family);
-		if (!cnt) cnt = name_from_dns_search(buf, canon, name, family);
+		if (cnt<=0) cnt = name_from_dns_search(buf, canon, name, family);
 	}
 	if (cnt<=0) return cnt ? cnt : EAI_NONAME;
@@ -352,34 +357,51 @@
 	 * So far the label/precedence table cannot be customized. */
 	for (i=0; i<cnt; i++) {
+		int family = buf[i].family;
 		int key = 0;
-		struct sockaddr_in6 sa, da = {
+		struct sockaddr_in6 sa6 = { 0 }, da6 = {
 			.sin6_family = AF_INET6,
 			.sin6_scope_id = buf[i].scopeid,
 			.sin6_port = 65535
 		};
-		if (buf[i].family == AF_INET6) {
-			memcpy(da.sin6_addr.s6_addr, buf[i].addr, 16);
+		struct sockaddr_in sa4 = { 0 }, da4 = {
+			.sin_family = AF_INET,
+			.sin_port = 65535
+		};
+		void *sa, *da;
+		socklen_t salen, dalen;
+		if (family == AF_INET6) {
+			memcpy(da6.sin6_addr.s6_addr, buf[i].addr, 16);
+			da = &da6; dalen = sizeof da6;
+			sa = &sa6; salen = sizeof sa6;
 		} else {
-			memcpy(da.sin6_addr.s6_addr,
+			memcpy(sa6.sin6_addr.s6_addr,
 				"\0\0\0\0\0\0\0\0\0\0\xff\xff", 12);
-			memcpy(da.sin6_addr.s6_addr+12, buf[i].addr, 4);
-		}
-		const struct policy *dpolicy = policyof(&da.sin6_addr);
-		int dscope = scopeof(&da.sin6_addr);
+			memcpy(da6.sin6_addr.s6_addr+12, buf[i].addr, 4);
+			memcpy(da6.sin6_addr.s6_addr,
+				"\0\0\0\0\0\0\0\0\0\0\xff\xff", 12);
+			memcpy(da6.sin6_addr.s6_addr+12, buf[i].addr, 4);
+			memcpy(&da4.sin_addr, buf[i].addr, 4);
+			da = &da4; dalen = sizeof da4;
+			sa = &sa4; salen = sizeof sa4;
+		}
+		const struct policy *dpolicy = policyof(&da6.sin6_addr);
+		int dscope = scopeof(&da6.sin6_addr);
 		int dlabel = dpolicy->label;
 		int dprec = dpolicy->prec;
 		int prefixlen = 0;
-		int fd = socket(AF_INET6, SOCK_DGRAM|SOCK_CLOEXEC, IPPROTO_UDP);
+		int fd = socket(family, SOCK_DGRAM|SOCK_CLOEXEC, IPPROTO_UDP);
 		if (fd >= 0) {
-			if (!connect(fd, (void *)&da, sizeof da)) {
+			if (!connect(fd, da, dalen)) {
 				key |= DAS_USABLE;
-				if (!getsockname(fd, (void *)&sa,
-				    &(socklen_t){sizeof sa})) {
-					if (dscope == scopeof(&sa.sin6_addr))
+				if (!getsockname(fd, sa, &salen)) {
+					if (family == AF_INET) memcpy(
+						sa6.sin6_addr.s6_addr+12,
+						&sa4.sin_addr, 4);
+					if (dscope == scopeof(&sa6.sin6_addr))
 						key |= DAS_MATCHINGSCOPE;
-					if (dlabel == labelof(&sa.sin6_addr))
+					if (dlabel == labelof(&sa6.sin6_addr))
 						key |= DAS_MATCHINGLABEL;
-					prefixlen = prefixmatch(&sa.sin6_addr,
-						&da.sin6_addr);
+					prefixlen = prefixmatch(&sa6.sin6_addr,
+						&da6.sin6_addr);
 				}
 			}
Index: asp3_tinet_ecnl_arm/trunk/ntshell/fatfs/ffarch.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/ntshell/fatfs/ffarch.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/ntshell/fatfs/ffarch.c	(revision 387)
@@ -80,5 +80,5 @@
 	ret2 = get_tim(&now);
 	if (ret2 != E_OK){
-		printf("[ffarch] get_tim error: %s",
+		syslog(LOG_NOTICE, "[ffarch] get_tim error: %s",
 			itron_strerror(ret2));
 		return;
@@ -94,5 +94,5 @@
 		ret = tslp_tsk(timer);
 		if ((ret != E_OK) && (ret != E_TMOUT)) {
-			printf("[ffarch] tslp_tsk error: %s %d",
+			syslog(LOG_NOTICE, "[ffarch] tslp_tsk error: %s %d",
 				itron_strerror(ret), timer);
 			break;
@@ -101,5 +101,5 @@
 		ret2 = get_tim(&now);
 		if (ret2 != E_OK) {
-			printf("[ffarch] get_tim error: %s",
+			syslog(LOG_NOTICE, "[ffarch] get_tim error: %s",
 				itron_strerror(ret2));
 			break;
@@ -131,5 +131,5 @@
 bool_t SD_begin();
 
-void ffarch_init()
+void ffarch_init(void)
 {
 	/* SD_CD */
@@ -150,8 +150,8 @@
 
 	if (romdisk_init()) {
-		printf("ROM disk (0:) OK!\n");
+		syslog(LOG_NOTICE, "ROM disk (0:) OK!");
 	}
 	else {
-		printf("ROM disk (0:) NG!\n");
+		syslog(LOG_NOTICE, "ROM disk (0:) NG!");
 	}
 }
@@ -352,5 +352,5 @@
 }
 
-int ffarch_get_timer()
+int ffarch_get_timer(void)
 {
 	return ffarch_timer;
@@ -367,5 +367,5 @@
 }
 
-void ffarch_timeout()
+void ffarch_timeout(void)
 {
 	if (ffarch_timer != 0)
@@ -375,5 +375,5 @@
 	case FFS_RETRY_WAIT:
 		if (ffarch_retry_count == 0) {
-			printf("SD card (1:) initialize tired...\n");
+			syslog(LOG_NOTICE, "SD card (1:) initialize tired...");
 
 			ffarch_state = FFS_IDLE;
@@ -388,8 +388,8 @@
  		if ((sdfs._is_initialized & STA_NOINIT)
  			|| (((sdfs_prev_status & STA_NODISK) != 0) && ((sdfs_new_status & STA_NODISK) == 0))) {
-			printf("SD card initializing ...\n");
+			syslog(LOG_NOTICE, "SD card initializing ...");
 
 			if (SD_begin()) {
-				printf("SD card (1:) OK!\n");
+				syslog(LOG_NOTICE, "SD card (1:) OK!");
 
 				/* uploadディレクトリを作成しておく */
@@ -401,5 +401,5 @@
 			}
 			else {
-				printf("SD card (1:) NG!\n");
+				syslog(LOG_NOTICE, "SD card (1:) NG!");
 				ffarch_state = FFS_RETRY_WAIT;
 				ffarch_timer = 1000 * 1000;
@@ -408,5 +408,5 @@
 		/* SDカードが抜かれた場合 */
 		else if (((sdfs_prev_status & STA_NODISK) == 0) && ((sdfs_new_status & STA_NODISK) != 0)) {
-			printf("SD card unmount\n");
+			syslog(LOG_NOTICE, "SD card unmount");
 
 			f_mount(&Sd.FatFs, "1:", 0);
Index: asp3_tinet_ecnl_arm/trunk/ntshell/ntshell/util/ntstdio.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/ntshell/ntshell/util/ntstdio.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/ntshell/ntshell/util/ntstdio.c	(revision 387)
@@ -224,6 +224,4 @@
 	handle->xi = xi;
 	handle->xo = xo;
-	handle->outptr = 0;
-	handle->len = 0;
 	handle->pos = 0;
 	handle->option = option;
@@ -232,12 +230,4 @@
 static void _putc(ntstdio_t *handle, char c)
 {
-	if (handle->outptr) {
-		if ((handle->pos + 1) >= handle->len)
-			return;
-		handle->outptr[handle->pos] = (unsigned char)c;
-		handle->pos++;
-		return;
-	}
-
 	if (handle->xo) {
 		handle->xo(handle, (unsigned char)c);
@@ -291,14 +281,32 @@
 }
 
+struct put_buf_t {
+	char *outptr;
+	int len;
+};
+
+static void put_buf(struct ntstdio_t *handle, unsigned char c)
+{
+	struct put_buf_t *put_buf = (struct put_buf_t *)handle->exinf;
+	if ((handle->pos + 1) >= put_buf->len)
+		return;
+	put_buf->outptr[handle->pos] = (char)c;
+	handle->pos++;
+}
+
 int ntstdio_snprintf(char *buf, int len, const char *fmt, ...)
 {
 	int result;
 	ntstdio_t handle;
+	struct put_buf_t exinf;
 	va_list arp;
 	/* Switch destination for memory */
+	handle.xo = put_buf;
 	handle.option = 0;
-	handle.outptr = buf;
-	handle.len = len;
 	handle.pos = 0;
+	handle.exinf = &exinf;
+	exinf.outptr = buf;
+	exinf.len = len;
+
 	va_start(arp, fmt);
 	result = xvprintf(&handle, fmt, arp);
@@ -306,5 +314,5 @@
 
 	/* Terminate output string with a \0 */
-	handle.outptr[handle.pos] = '\0';
+	buf[handle.pos] = '\0';
 	return result;
 }
Index: asp3_tinet_ecnl_arm/trunk/ntshell/ntshell/util/ntstdio.h
===================================================================
--- asp3_tinet_ecnl_arm/trunk/ntshell/ntshell/util/ntstdio.h	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/ntshell/ntshell/util/ntstdio.h	(revision 387)
@@ -74,6 +74,4 @@
 	NTSTDIO_XI xi;
 	NTSTDIO_XO xo;
-	char *outptr;
-	int len;
 	int pos;
 	unsigned int option;
